#include <hmg.ch>

PROCEDURE edit_DATA2

   PUBLIC New := .F. , _qry_exp := ""
   
   use_data1()
   Use_data2() 

   DEFINE WINDOW Win_2 ;
      AT 0,0 ;
      WIDTH 800 ;
      HEIGHT 700 ;
      TITLE "Table DATA2" ;
      MODAL ;
      ON RELEASE closetables2() 

      ON KEY ESCAPE ACTION Win_2.Release

      DEFINE STATUSBAR FONT "Arial" SIZE 12
         STATUSITEM "Table DATA2"
         KEYBOARD
         DATE
         CLOCK
      END STATUSBAR

      DEFINE TOOLBAR ToolBar_2 BUTTONSIZE 60,40 IMAGESIZE 32,32 FLAT BORDER

      BUTTON FIRST_0389 ;
         CAPTION "First" ;
         PICTURE "go_first.bmp" ;
         ACTION( dbGotop(), Win_2.Browse_2.Value := RecNo() )

      BUTTON PREV_0389 ;
         CAPTION "Prev" ;
         PICTURE "go_prev.bmp" ;
         ACTION( dbSkip( -1 ), Win_2.Browse_2.Value := RecNo() )

      BUTTON NEXT_0389 ;
         CAPTION "Next" ;
         PICTURE "go_next.bmp" ;
         ACTION( dbSkip(), if ( Eof(), dbGobottom(), Nil ), Win_2.Browse_2.Value := RecNo() )

      BUTTON LAST_0389 ;
         CAPTION "Last" ;
         PICTURE "go_last.bmp" ;
         ACTION( dbGoBottom(), Win_2.Browse_2.Value := RecNo() )   SEPARATOR 

      BUTTON FIND_0389 ;
         CAPTION "Find" ;
         PICTURE "edit_find.bmp" ;
         ACTION Find_0389()

      BUTTON NEW_0389 ;
         CAPTION "New" ;
         PICTURE "edit_new.bmp" ;
         ACTION ( New := .T., NewRecord_0389() )

      BUTTON EDIT_0389 ;
         CAPTION "Edit" ;
         PICTURE "edit_edit.bmp" ;
         ACTION If ( RecordStatus_0389(), EnableField_0389(), Nil )

      BUTTON DELETE_0389 ;
         CAPTION "Delete" ;
         PICTURE "edit_delete.bmp" ;
         ACTION ( RecordStatus_0389(), DeleteRecord_0389(), Nil )

      BUTTON PRINT_0389 ;
         CAPTION "Print" ;
         PICTURE "edit_print.bmp" ;
         ACTION PrintData_0389()

      BUTTON EXIT_0389 ;
         CAPTION "Exit" ;
         PICTURE "edit_close.bmp" ;
         ACTION Win_2.Release

      END TOOLBAR

      PaintDisplay_0389()

      @ 90,10 BROWSE Browse_2 ;
         OF Win_2 ;
         WIDTH 750 ;
         HEIGHT 350 ;
         FONT "Arial" ; 
         SIZE 11 ;
         HEADERS { "DATUM","ID","DESCRIPTION","EXPENSE","PAYMENT","DATUM2" } ;
         WIDTHS { 110,70,210,110,110,110 } ;
         WORKAREA DATA2 ;
         FIELDS { "DATUM","ID_PAY","DESCRIPT","EXPENSE","PAYMENT","DATUM2" } ;
         JUSTIFY { , BROWSE_JTFY_RIGHT, , BROWSE_JTFY_RIGHT, BROWSE_JTFY_RIGHT, } ;
         ON CHANGE LoadData_0389() ;
         ON HEADCLICK { {||head1_0389()}, {||head2_0389()} } ;
         ON DBLCLICK ( EnableField_0389(), If ( ! RecordStatus_0389(), DisableField_0389(), Nil ) )

      @ 580, 50 BUTTON SAVE_0389 ;
         CAPTION "Save" ;
         PICTURE "ok.bmp" RIGHT ;
         ACTION SaveRecord_0389() ;
         WIDTH 100 ;
         HEIGHT 40 

      @ 580,150 BUTTON CANCEL_0389 ;
         CAPTION "Cancel" ;
         PICTURE "cancel.bmp" RIGHT ;
         ACTION CancelEdit_0389() ;
         WIDTH 100 ;
         HEIGHT 40 

      @ 580,300 BUTTON QUERY_0389 ;
         CAPTION "Query" ;
         PICTURE "edit_find.bmp" RIGHT ;
         ACTION QueryRecord_0389() ;
         WIDTH 100 ;
         HEIGHT 40 

   END WINDOW

   DisableField_0389()

   Win_2.Browse_2.SetFocus
   Win_2.Browse_2.Value := DATA2->(RecNo())

   ACTIVATE WINDOW Win_2

RETURN
*---------------------------------------------*
PROCEDURE DisableField_0389

   Win_2.Browse_2.Enabled      := .T.

   Win_2.mDATUM.Enabled        := .F.
   Win_2.mID_PAY.Enabled       := .F.
   Win_2.mDESCRIPT.Enabled     := .F.
   Win_2.mEXPENSE.Enabled      := .F.
   Win_2.mPAYMENT.Enabled      := .F.
   Win_2.mDATUM2.Enabled       := .F.

   Win_2.Save_0389.Enabled     := .F.
   Win_2.Cancel_0389.Enabled   := .F.
   Win_2.Query_0389.Enabled    := .F.
   Win_2.Toolbar_2.Enabled     := .T.
   Win_2.Browse_2.SetFocus

RETURN
*---------------------------------------------*
PROCEDURE EnableField_0389

   Win_2.Browse_2.Enabled      := .F.

   Win_2.mDATUM.Enabled        := .T.
   Win_2.mID_PAY.Enabled       := .T.
   Win_2.mDESCRIPT.Enabled     := .T.
   Win_2.mEXPENSE.Enabled      := .T.
   Win_2.mPAYMENT.Enabled      := .T.
   Win_2.mDATUM2.Enabled       := .T.

   Win_2.Save_0389.Enabled     := .T.
   Win_2.Cancel_0389.Enabled   := .T.
   Win_2.Query_0389.Enabled    := .F.
   Win_2.Toolbar_2.Enabled     := .F.
   Win_2.mID_PAY.SetFocus

RETURN
*---------------------------------------------*
FUNCTION RecordStatus_0389()

   Local RetVal

   DATA2->( dbGoTo ( Win_2.Browse_2.Value ) )

   IF DATA2->(RLock())
      RetVal := .T.
   ELSE
      MsgExclamation ("Record LOCKED, try again later")
      RetVal := .F.
   ENDIF

RETURN RetVal
*---------------------------------------------*
PROCEDURE LoadData_0389

   DATA2->( dbGoTo ( Win_2.Browse_2.Value ) )

   Win_2.mDATUM.Value        := DATA2->DATUM     
   Win_2.mID_PAY.Value       := DATA2->ID_PAY    
   Win_2.mDESCRIPT.Value     := DATA2->DESCRIPT  
   Win_2.mEXPENSE.Value      := DATA2->EXPENSE   
   Win_2.mPAYMENT.Value      := DATA2->PAYMENT   
   Win_2.mDATUM2.Value       := DATA2->DATUM2    

RETURN
*---------------------------------------------*
PROCEDURE CancelEdit_0389

   DisableField_0389()
   LoadData_0389()
   UNLOCK
   New := .F.

RETURN
*---------------------------------------------*
PROCEDURE SaveRecord_0389

   Local NewRecNo

   DisableField_0389()

   IF New == .T.
      DATA2->(dbAppend())
      New := .F.
   ELSE
      DATA2->(dbGoto ( Win_2.Browse_2.Value ) )
   ENDIF

   NewRecNo := DATA2->( RecNo() )

   DATA2->DATUM      := Win_2.mDATUM.Value
   DATA2->ID_PAY     := Win_2.mID_PAY.Value
   DATA2->DESCRIPT   := Win_2.mDESCRIPT.Value
   DATA2->EXPENSE    := Win_2.mEXPENSE.Value
   DATA2->PAYMENT    := Win_2.mPAYMENT.Value
   DATA2->DATUM2     := Win_2.mDATUM2.Value

   Win_2.Browse_2.Refresh
   IF New == .T.
      Win_2.Browse_2.Value := NewRecNo 
   ENDIF

   UNLOCK
   dbCommitall()

   Win_2.StatusBar.Item(1) := "Save Record" 

RETURN
*---------------------------------------------*
PROCEDURE NewRecord_0389

   Win_2.StatusBar.Item(1) := "Editing" 

   SET ORDER TO 1
   dbGoBottom()

   Win_2.mDATUM.Value        := date()
   Win_2.mID_PAY.Value       := 0
   Win_2.mDESCRIPT.Value     := space(20)
   Win_2.mEXPENSE.Value      := 0
   Win_2.mPAYMENT.Value      := 0
   Win_2.mDATUM2.Value       := date()

   EnableField_0389()

   Win_2.mID_PAY.SetFocus

RETURN
*---------------------------------------------*
PROCEDURE DeleteRecord_0389

   IF MsgYesNo ( "Are you sure do you want delete record?" )
      IF DATA2->(FLock())
         DELETE
         Win_2.Browse_2.Refresh
         UNLOCK
      ENDIF
   ENDIF

RETURN
*---------------------------------------------*
PROCEDURE Find_0389

   Win_2.StatusBar.Item(1) := "Query" 

   Win_2.mDATUM.Value        := date()
   Win_2.mID_PAY.Value       := 0
   Win_2.mDESCRIPT.Value     := space(20)
   Win_2.mEXPENSE.Value      := 0
   Win_2.mPAYMENT.Value      := 0
   Win_2.mDATUM2.Value       := date()

   EnableField_0389()
   Win_2.Save_0389.Enabled  := .F.
   Win_2.Query_0389.Enabled := .T.
   Win_2.Control_1.SetFocus

RETURN
*---------------------------------------------*
PROCEDURE PrintData_0389

   Local RecRec 

   RecRec := DATA2->( RecNo())
   dbGoTop()
   DO REPORT ;
      TITLE "DATA2" ;
      HEADERS { "","","","","","" }, { "DATUM","ID_PAY","DESCRIPT","EXPENSE","PAYMENT","DATUM2" } ;
      FIELDS { "DATUM","ID_PAY","DESCRIPT","EXPENSE","PAYMENT","DATUM2" } ;
      WIDTHS { 11,7,21,11,11,11 } ;
      TOTALS { .F.,.F.,.F.,.F.,.F.,.F. } ;
      WORKAREA DATA2 ;
      LPP 50 ;
      CPL 80 ;
      LMARGIN 5 ;
      PREVIEW
   DATA2->(dbGoTo(RecRec))

RETURN
*---------------------------------------------*
PROCEDURE PaintDisplay_0389

   @ 450,10 FRAME Frame_2 WIDTH 750 HEIGHT 100

   @ 470, 20 LABEL Label_1 VALUE "DATE"
   @ 470, 120 LABEL Label_2 VALUE "PAY"
   @ 470, 190 LABEL Label_3 VALUE "DESCRIPTION"
   @ 470, 400 LABEL Label_4 VALUE "EXPENSE"
   @ 470, 510 LABEL Label_5 VALUE "PAYMENT"
   @ 470, 620 LABEL Label_6 VALUE "PAY DATE"
   @ 520, 120 LABEL Label_pay VALUE "            "
   
   @ 490, 20 TEXTBOX  mDATUM        WIDTH  95 DATE 
   @ 490, 120 TEXTBOX  mID_PAY      WIDTH 60 NUMERIC INPUTMASK "9999" on lostfocus valid_pay() on Enter valid_pay()
   @ 490, 190 TEXTBOX  mDESCRIPT    WIDTH 205 INPUTMASK "!!!!!!!!!!!!!!!!!!!!"
   @ 490, 400 TEXTBOX  mEXPENSE     WIDTH 105 NUMERIC INPUTMASK "9999,999.99"
   @ 490, 510 TEXTBOX  mPAYMENT     WIDTH 105 NUMERIC INPUTMASK "9999,999.99"
   @ 490, 620 TEXTBOX  mDATUM2      WIDTH 100 DATE 
  
   
RETURN
*---------------------------------------------*
PROCEDURE Head1_0389

   SELECT DATA2
   SET ORDER TO 1
   dbGotop()
   Win_2.Browse_2.Value := RecNo()
   Win_2.Browse_2.Refresh
   LoadData_0389()

RETURN
*---------------------------------------------*
PROCEDURE Head2_0389

   SELECT DATA2
   SET ORDER TO 2
   dbGotop()
   Win_2.Browse_2.Value := RecNo()
   Win_2.Browse_2.Refresh
   LoadData_0389()

RETURN
*---------------------------------------------*
PROCEDURE QueryRecord_0389

   PreQuery_0389()

   SET FILTER TO &_qry_exp
   dbGotop()

   IF ! EMPTY( _qry_exp )
      COUNT TO found_rec FOR &_qry_exp
      dbGotop()

      IF found_rec = 0
         Win_2.Statusbar.Item(1) := "Not found!"
      ELSE
         Win_2.Statusbar.Item(1) := "Found " + ALLTRIM(STR(found_rec)) + " record(s)!"
      ENDIF
   ENDIF

   DisableField_0389()

   Win_2.Browse_2.Refresh
   Win_2.Browse_2.Enabled   := .T.

RETURN
*---------------------------------------------*
PROCEDURE PreQuery_0389

_qry_exp := ""
_ima_filter := .F.

IF ! EMPTY ( Win_2.mDATUM.Value )     // DATUM
   IF _ima_filter
      _qry_exp = _qry_exp + " .AND. "
   ENDIF
      _qry_exp = _qry_exp + "DATUM = " + "CTOD(" + chr(34) + DTOC(Win_2.mDATUM.Value) + chr(34) + ")"
      _ima_filter := .T.
ENDIF

IF ! EMPTY ( Win_2.mID_PAY.Value )     // ID_PAY
   IF _ima_filter
      _qry_exp = _qry_exp + " .AND. "
   ENDIF
      _qry_exp = _qry_exp + "ID_PAY = " + STR( Win_2.mID_PAY.Value )
      _ima_filter := .T.
ENDIF

IF ! EMPTY ( Win_2.mDESCRIPT.Value )     // DESCRIPT
   IF _ima_filter
      _qry_exp = _qry_exp + " .AND. "
   ENDIF
      _qry_exp = _qry_exp + "DESCRIPT = " + chr(34) + Win_2.mDESCRIPT.Value + chr(34)
      _ima_filter := .T.
ENDIF

IF ! EMPTY ( Win_2.mEXPENSE.Value )     // EXPENSE
   IF _ima_filter
      _qry_exp = _qry_exp + " .AND. "
   ENDIF
      _qry_exp = _qry_exp + "EXPENSE = " + STR( Win_2.mEXPENSE.Value )
      _ima_filter := .T.
ENDIF

IF ! EMPTY ( Win_2.mPAYMENT.Value )     // PAYMENT
   IF _ima_filter
      _qry_exp = _qry_exp + " .AND. "
   ENDIF
      _qry_exp = _qry_exp + "PAYMENT = " + STR( Win_2.mPAYMENT.Value )
      _ima_filter := .T.
ENDIF

IF ! EMPTY ( Win_2.mDATUM2.Value )     // DATUM2
   IF _ima_filter
      _qry_exp = _qry_exp + " .AND. "
   ENDIF
      _qry_exp = _qry_exp + "DATUM2 = " + "CTOD(" + chr(34) + DTOC(Win_2.mDATUM2.Value) + chr(34) + ")"
      _ima_filter := .T.
ENDIF

RETURN
*:************************************************
function valid_pay ()

select data1
seek win_2.mID_PAY.value

win_2.label_pay.value := data1->descript

select data2

return 0
*:************************************************
function closetables2 ()

   dbcloseall()

return 0


