#include "hmg.ch"

Procedure Report_2

   SET BROWSESYNC ON
   SET NAVIGATION EXTENDED
   set date german

   DEFINE WINDOW Rep_2 ;
      AT 0, 0 ;
      WIDTH 400 ;
      HEIGHT 400 ;
      TITLE "REPORT" ;
      MODAL 

      ON KEY ESCAPE ACTION Rep_2.Release 

      @ 50, 100  LABEL Label_2 VALUE "From"
      @ 50, 150  TEXTBOX  pDATUM       DATE 
      @ 80, 100  LABEL Label_6 VALUE "To"
      @ 80, 150  TEXTBOX  pDATUM2      DATE 

   @ 150, 150 BUTTON PRINT_5226 ;
      CAPTION " Create report " ;
      ACTION rep_create_5226() ;
      WIDTH 100

   END WINDOW

   rep_2.pDatum.value := date()-30
   rep_2.pDatum2.value := date()
     
   Rep_2.CENTER
   ACTIVATE WINDOW Rep_2

RETURN
*----------------------------------------*
PROCEDURE rep_create_5226

PRIVATE mPrinter, nCurLine:=300, nCurPage:=0, nPageSize:=280
PRIVATE cFontName:="Courier", nFontSize:=10, nFontHeight:=5

_dat1 = rep_2.pDatum.value
_dat2 = rep_2.pDatum2.value

pre_rep2( _dat1, _dat2 )

USE_REPORT()   // function from USE_DBF.prg 
set order to 2

brk_01    := ID_PAY    
brk_on_01 := .F.
prt_01    := .T.
sum_01_04 := 0 
sum_01_05 := 0 

sumr_04 := 0 
sumr_05 := 0 

   mPrinter := GetPrinter()
   IF Empty ( mPrinter )
      MsgExclamation( "Printer not selected" )
      RETURN NIL
   ENDIF

   SELECT PRINTER mPrinter ;
      ORIENTATION PRINTER_ORIENT_PORTRAIT ;
      PAPERSIZE PRINTER_PAPER_A4 ;
      PREVIEW 

   START PRINTDOC NAME "report" 

DBGOTOP()
DO WHILE .NOT. EOF()

sumr_04 := sumr_04 + EXPENSE   
sumr_05 := sumr_05 + PAYMENT   

   IF brk_01 <> ID_PAY    
      brk_on_01 := .T.
      prt_01    := .T.
   ENDIF

   IF brk_01 <> ID_PAY .OR. brk_on_01

      nCurLine += nFontHeight
      @ nCurLine,   5 PRINT replicate("*",  6) FONT "Courier" SIZE 10
      @ nCurLine,  83 PRINT replicate("-", 10) FONT "Courier" SIZE 10
      @ nCurLine, 105 PRINT replicate("-", 10) FONT "Courier" SIZE 10

      nCurLine += nFontHeight
      @ nCurLine,   5 PRINT "sum" FONT "Courier" SIZE 10
      @ nCurLine,  83 PRINT  TRANSFORM ( sum_01_04, "9999999.99") FONT "Courier" SIZE 10
      @ nCurLine, 105 PRINT  TRANSFORM ( sum_01_05, "9999999.99") FONT "Courier" SIZE 10
      nCurLine += nFontHeight

      brk_01 := ID_PAY    
      brk_on_01 := .F.
      sum_01_04 := 0 
      sum_01_05 := 0 

   ENDIF

   sum_01_04 := sum_01_04 + EXPENSE   
   sum_01_05 := sum_01_05 + PAYMENT   

   IF nCurLine > nPageSize
      hdr_5226()
   ENDIF

   nCurLine += nFontHeight
   IF prt_01
      @ nCurLine,   5 PRINT  TRANSFORM ( ID_PAY, "9999") FONT "Courier" SIZE 10
      @ nCurLine,  20 PRINT  PAYDESC
      nCurLine += nFontHeight   
      prt_01 := .F.
   ENDIF
   @ nCurLine,  19 PRINT DATUM      FONT "Courier" SIZE 10
   @ nCurLine,  41 PRINT  TRANSFORM ( DESCRIPT, "XXXXXXXXXXXXXXXXXXXX") FONT "Courier" SIZE 10
   @ nCurLine,  83 PRINT  TRANSFORM ( EXPENSE, "9999999.99") FONT "Courier" SIZE 10
   @ nCurLine, 105 PRINT  TRANSFORM ( PAYMENT, "9999999.99") FONT "Courier" SIZE 10
   @ nCurLine, 127 PRINT DATUM2     FONT "Courier" SIZE 10

   DBSKIP()
ENDDO

nCurLine += nFontHeight
@ nCurLine,   5 PRINT replicate("*",  6) FONT "Courier" SIZE 10
@ nCurLine,  83 PRINT replicate("-", 10) FONT "Courier" SIZE 10
@ nCurLine, 105 PRINT replicate("-", 10) FONT "Courier" SIZE 10

nCurLine += nFontHeight
@ nCurLine,   5 PRINT "sum" FONT "Courier" SIZE 10
@ nCurLine,  83 PRINT  TRANSFORM ( sum_01_04, "9999999.99") FONT "Courier" SIZE 10
@ nCurLine, 105 PRINT  TRANSFORM ( sum_01_05, "9999999.99") FONT "Courier" SIZE 10

nCurLine += nFontHeight
@ nCurLine,  83 PRINT replicate("=", 10) FONT "Courier" SIZE 10
@ nCurLine, 105 PRINT replicate("=", 10) FONT "Courier" SIZE 10

nCurLine += nFontHeight
@ nCurLine,  83 PRINT  TRANSFORM ( sumr_04, "9999999.99") FONT "Courier" SIZE 10
@ nCurLine, 105 PRINT  TRANSFORM ( sumr_05, "9999999.99") FONT "Courier" SIZE 10

   END PRINTPAGE
END PRINTDOC

DBCLOSEALL()

Rep_2.RELEASE

RETURN 0
*----------------------------------------*
FUNCTION hdr_5226

nCurPage++
nCurLine := 1

IF nCurPage > 1
   END PRINTPAGE
ENDIF

   START PRINTPAGE

@ nCurLine, 10 PRINT "Date : " + DTOC(date()) FONT "Courier" SIZE 10 
@ nCurLine, 180 PRINT "Page : " + STR(nCurPage, 3) FONT "Courier" SIZE 10
@ nCurLine, 100 PRINT "PAYMENTS for period" FONT "Courier" SIZE 14 CENTER

nCurLine += nFontHeight
@ nCurLine,   5 PRINT "PAY" FONT "Courier" SIZE 10
@ nCurLine,  19 PRINT "DATE" FONT "Courier" SIZE 10
@ nCurLine,  41 PRINT "DESCRIPTION" FONT "Courier" SIZE 10
@ nCurLine,  83 PRINT "EXPENSE" FONT "Courier" SIZE 10
@ nCurLine, 105 PRINT "PAYMENT" FONT "Courier" SIZE 10
@ nCurLine, 127 PRINT "DATE PAY" FONT "Courier" SIZE 10

nCurLine += nFontHeight
@ nCurLine,   5 PRINT replicate("=",  6) FONT "Courier" SIZE 10
@ nCurLine,  19 PRINT replicate("=", 10) FONT "Courier" SIZE 10
@ nCurLine,  41 PRINT replicate("=", 20) FONT "Courier" SIZE 10
@ nCurLine,  83 PRINT replicate("=", 10) FONT "Courier" SIZE 10
@ nCurLine, 105 PRINT replicate("=", 10) FONT "Courier" SIZE 10
@ nCurLine, 127 PRINT replicate("=", 10) FONT "Courier" SIZE 10

prt_01 := .T.

RETURN 0
