#include "hmg.ch"

Procedure Report_1

   SET BROWSESYNC ON
   SET NAVIGATION EXTENDED

   DEFINE WINDOW Rep_1 ;
      AT 0, 0 ;
      WIDTH 400 ;
      HEIGHT 400 ;
      TITLE "REPORT" ;
      MODAL 

      ON KEY ESCAPE ACTION Rep_1.Release 

   @ 150, 150 BUTTON PRINT_4685 ;
      CAPTION " Create report " ;
      ACTION rep_create_4685() ;
      WIDTH 100

   END WINDOW

   Rep_1.CENTER
   ACTIVATE WINDOW Rep_1

RETURN
*----------------------------------------*
PROCEDURE rep_create_4685

PRIVATE mPrinter, nCurLine:=300, nCurPage:=0, nPageSize:=280
PRIVATE cFontName:="Courier", nFontSize:=10, nFontHeight:=5

pre_rep1()

USE_REPORT()   // function from USE_DBF.prg 

sumr_03 := 0 

   mPrinter := GetPrinter()
   IF Empty ( mPrinter )
      MsgExclamation( "Printer not selected" )
      RETURN NIL
   ENDIF

   SELECT PRINTER mPrinter ;
      ORIENTATION PRINTER_ORIENT_PORTRAIT ;
      PAPERSIZE PRINTER_PAPER_A4 ;
      PREVIEW 

   START PRINTDOC NAME "report" 

DBGOTOP()
DO WHILE .NOT. EOF()

sumr_03 := sumr_03 + SALDO     

   IF nCurLine > nPageSize
      hdr_4685()
   ENDIF

   nCurLine += nFontHeight
   @ nCurLine,   5 PRINT  TRANSFORM ( ID_PAY, "9999") FONT "Courier" SIZE 10
   @ nCurLine,  15 PRINT  TRANSFORM ( PAYDESC, "XXXXXXXXXXXXXXXXXXXX") FONT "Courier" SIZE 10
   @ nCurLine,  57 PRINT  TRANSFORM ( SALDO, "9999,999.99") FONT "Courier" SIZE 10

   DBSKIP()
ENDDO

nCurLine += nFontHeight
@ nCurLine,  57 PRINT replicate("=", 11) FONT "Courier" SIZE 10

nCurLine += nFontHeight
@ nCurLine,  57 PRINT  TRANSFORM ( sumr_03, "9999,999.99") FONT "Courier" SIZE 10

   END PRINTPAGE
END PRINTDOC

DBCLOSEALL()

Rep_1.RELEASE

RETURN 0
*----------------------------------------*
FUNCTION hdr_4685

nCurPage++
nCurLine := 1

IF nCurPage > 1
   END PRINTPAGE
ENDIF

   START PRINTPAGE

@ nCurLine, 10 PRINT "Date : " + DTOC(date()) FONT "Courier" SIZE 10 
@ nCurLine, 180 PRINT "Page : " + STR(nCurPage, 3) FONT "Courier" SIZE 10
@ nCurLine, 100 PRINT "PAYMENT SALDO today" FONT "Courier" SIZE 14 CENTER

nCurLine += nFontHeight
@ nCurLine,   5 PRINT "PAY" FONT "Courier" SIZE 10
@ nCurLine,  15 PRINT "DESCRIPTION" FONT "Courier" SIZE 10
@ nCurLine,  57 PRINT "SALDO" FONT "Courier" SIZE 10

nCurLine += nFontHeight
@ nCurLine,   5 PRINT replicate("=",  4) FONT "Courier" SIZE 10
@ nCurLine,  15 PRINT replicate("=", 20) FONT "Courier" SIZE 10
@ nCurLine,  57 PRINT replicate("=", 11) FONT "Courier" SIZE 10


RETURN 0
