#include <hmg.ch>

PROCEDURE edit_DATA1

   PUBLIC New := .F. , _qry_exp := ""

   Use_data1() ; // use_dbf.prg 

   DEFINE WINDOW Win_1 ;
      AT 0,0 ;
      WIDTH 800 ;
      HEIGHT 700 ;
      TITLE "Table Types" ;
      MODAL ;
      ON RELEASE closetables1()

      ON KEY ESCAPE ACTION Win_1.Release

      DEFINE STATUSBAR FONT "Arial" SIZE 12
         STATUSITEM "Types"
         KEYBOARD
         DATE
         CLOCK
      END STATUSBAR

      DEFINE TOOLBAR ToolBar_1 BUTTONSIZE 60,40 IMAGESIZE 32,32 FLAT BORDER

      BUTTON FIRST_9213 ;
         CAPTION "First" ;
         PICTURE "go_first.bmp" ;
         ACTION( dbGotop(), Win_1.Browse_1.Value := RecNo() )

      BUTTON PREV_9213 ;
         CAPTION "Prev" ;
         PICTURE "go_prev.bmp" ;
         ACTION( dbSkip( -1 ), Win_1.Browse_1.Value := RecNo() )

      BUTTON NEXT_9213 ;
         CAPTION "Next" ;
         PICTURE "go_next.bmp" ;
         ACTION( dbSkip(), if ( Eof(), dbGobottom(), Nil ), Win_1.Browse_1.Value := RecNo() )

      BUTTON LAST_9213 ;
         CAPTION "Last" ;
         PICTURE "go_last.bmp" ;
         ACTION( dbGoBottom(), Win_1.Browse_1.Value := RecNo() )   SEPARATOR 

      BUTTON FIND_9213 ;
         CAPTION "Find" ;
         PICTURE "edit_find.bmp" ;
         ACTION Find_9213()

      BUTTON NEW_9213 ;
         CAPTION "New" ;
         PICTURE "edit_new.bmp" ;
         ACTION ( New := .T., NewRecord_9213() )

      BUTTON EDIT_9213 ;
         CAPTION "Edit" ;
         PICTURE "edit_edit.bmp" ;
         ACTION If ( RecordStatus_9213(), EnableField_9213(), Nil )

      BUTTON DELETE_9213 ;
         CAPTION "Delete" ;
         PICTURE "edit_delete.bmp" ;
         ACTION ( RecordStatus_9213(), DeleteRecord_9213(), Nil )

      BUTTON PRINT_9213 ;
         CAPTION "Print" ;
         PICTURE "edit_print.bmp" ;
         ACTION PrintData_9213()

      BUTTON EXIT_9213 ;
         CAPTION "Exit" ;
         PICTURE "edit_close.bmp" ;
         ACTION Win_1.Release

      END TOOLBAR

      PaintDisplay_9213()

      @ 90,10 BROWSE Browse_1 ;
         OF Win_1 ;
         WIDTH 500 ;
         HEIGHT 300 ;
         FONT "Arial" ; 
         SIZE 11 ;
         HEADERS { "ID","DESCRIPT" } ;
         WIDTHS { 50,210 } ;
         WORKAREA DATA1 ;
         FIELDS { "ID","DESCRIPT" } ;
         ON CHANGE LoadData_9213() ;
         ON HEADCLICK { {||head1_9213()}, {||head2_9213()} } ;
         ON DBLCLICK ( EnableField_9213(), If ( ! RecordStatus_9213(), DisableField_9213(), Nil ) )

      @ 580, 50 BUTTON SAVE_9213 ;
         CAPTION "Save" ;
         PICTURE "ok.bmp" RIGHT ;
         ACTION SaveRecord_9213() ;
         WIDTH 100 ;
         HEIGHT 40 

      @ 580,150 BUTTON CANCEL_9213 ;
         CAPTION "Cancel" ;
         PICTURE "cancel.bmp" RIGHT ;
         ACTION CancelEdit_9213() ;
         WIDTH 100 ;
         HEIGHT 40 

      @ 580,300 BUTTON QUERY_9213 ;
         CAPTION "Query" ;
         PICTURE "edit_find.bmp" RIGHT ;
         ACTION QueryRecord_9213() ;
         WIDTH 100 ;
         HEIGHT 40 

   END WINDOW

   DisableField_9213()

   Win_1.Browse_1.SetFocus
   Win_1.Browse_1.Value := DATA1->(RecNo())

   ACTIVATE WINDOW Win_1

RETURN
*:---------------------------------------------*
PROCEDURE DisableField_9213

   Win_1.Browse_1.Enabled      := .T.

   Win_1.mID.Enabled           := .F.
   Win_1.mDESCRIPT.Enabled     := .F.

   Win_1.Save_9213.Enabled     := .F.
   Win_1.Cancel_9213.Enabled   := .F.
   Win_1.Query_9213.Enabled    := .F.
   Win_1.Toolbar_1.Enabled     := .T.
   Win_1.Browse_1.SetFocus

RETURN
*:---------------------------------------------*
PROCEDURE EnableField_9213

   Win_1.Browse_1.Enabled      := .F.

   Win_1.mID.Enabled           := .T.
   Win_1.mDESCRIPT.Enabled     := .T.

   Win_1.Save_9213.Enabled     := .T.
   Win_1.Cancel_9213.Enabled   := .T.
   Win_1.Query_9213.Enabled    := .F.
   Win_1.Toolbar_1.Enabled     := .F.
   Win_1.mDESCRIPT.SetFocus

RETURN
*:---------------------------------------------*
FUNCTION RecordStatus_9213()

   Local RetVal

   DATA1->( dbGoTo ( Win_1.Browse_1.Value ) )

   IF DATA1->(RLock())
      RetVal := .T.
   ELSE
      MsgExclamation ("Record LOCKED, try again later")
      RetVal := .F.
   ENDIF

RETURN RetVal
*:---------------------------------------------*
PROCEDURE LoadData_9213

   DATA1->( dbGoTo ( Win_1.Browse_1.Value ) )

   Win_1.mID.Value           := DATA1->ID        
   Win_1.mDESCRIPT.Value     := DATA1->DESCRIPT  

RETURN
*---------------------------------------------*
PROCEDURE CancelEdit_9213

   DisableField_9213()
   LoadData_9213()
   UNLOCK
   New := .F.

RETURN
*---------------------------------------------*
PROCEDURE SaveRecord_9213

   Local NewRecNo

   DisableField_9213()

   IF New == .T.
      DATA1->(dbAppend())
      New := .F.
   ELSE
      DATA1->(dbGoto ( Win_1.Browse_1.Value ) )
   ENDIF

   NewRecNo := DATA1->( RecNo() )

   DATA1->ID         := Win_1.mID.Value
   DATA1->DESCRIPT   := Win_1.mDESCRIPT.Value

   Win_1.Browse_1.Refresh
   IF New == .T.
      Win_1.Browse_1.Value := NewRecNo 
   ENDIF

   UNLOCK
   dbCommitall()

   Win_1.StatusBar.Item(1) := "Save Record" 

RETURN
*---------------------------------------------*
PROCEDURE NewRecord_9213

   Win_1.StatusBar.Item(1) := "Editing" 

   SET ORDER TO 1
   dbGoBottom()

   Win_1.mID.Value          := id + 1
   Win_1.mDESCRIPT.Value     := space(20)

   EnableField_9213()

   Win_1.mDESCRIPT.SetFocus

RETURN
*---------------------------------------------*
PROCEDURE DeleteRecord_9213

   IF MsgYesNo ( "Are you sure do you want delete record?" )
      IF DATA1->(FLock())
         DELETE
         Win_1.Browse_1.Refresh
         UNLOCK
      ENDIF
   ENDIF

RETURN
*---------------------------------------------*
PROCEDURE Find_9213

   Win_1.StatusBar.Item(1) := "Query" 

   Win_1.mID.Value           := 0
   Win_1.mDESCRIPT.Value     := space(20)

   EnableField_9213()
   Win_1.Save_9213.Enabled  := .F.
   Win_1.Query_9213.Enabled := .T.
   Win_1.Control_1.SetFocus

RETURN
*---------------------------------------------*
PROCEDURE PrintData_9213

   Local RecRec 

   RecRec := DATA1->( RecNo())
   dbGoTop()
   DO REPORT ;
      TITLE "DATA1" ;
      HEADERS { "","" }, { "ID","DESCRIPT" } ;
      FIELDS { "ID","DESCRIPT" } ;
      WIDTHS { 5,21 } ;
      TOTALS { .F.,.F. } ;
      WORKAREA DATA1 ;
      LPP 50 ;
      CPL 80 ;
      LMARGIN 5 ;
      PREVIEW
   DATA1->(dbGoTo(RecRec))

RETURN
*---------------------------------------------*
PROCEDURE PaintDisplay_9213

   @  400,10 FRAME Frame_1 WIDTH 500 HEIGHT 80

   @ 410, 30 LABEL Label_1 VALUE "ID"
   @ 410, 100 LABEL Label_2 VALUE "DESCRIPTION"

   @ 430, 30 TEXTBOX  mID          WIDTH 50 NUMERIC INPUTMASK "9999"
   @ 430, 100 TEXTBOX  mDESCRIPT    WIDTH 210 INPUTMASK "!!!!!!!!!!!!!!!!!!!!"

RETURN
*---------------------------------------------*
PROCEDURE Head1_9213

   SELECT DATA1
   SET ORDER TO 1
   dbGotop()
   Win_1.Browse_1.Value := RecNo()
   Win_1.Browse_1.Refresh
   LoadData_9213()

RETURN
*---------------------------------------------*
PROCEDURE Head2_9213

   SELECT DATA1
   SET ORDER TO 2
   dbGotop()
   Win_1.Browse_1.Value := RecNo()
   Win_1.Browse_1.Refresh
   LoadData_9213()

RETURN
*---------------------------------------------*
PROCEDURE QueryRecord_9213

   PreQuery_9213()

   SET FILTER TO 
   dbGotop()

   IF ! EMPTY( _qry_exp )
      COUNT TO found_rec FOR &_qry_exp
      dbGotop()

      IF found_rec = 0
         Win_1.Statusbar.Item(1) := "Not found!"
      ELSE
         Win_1.Statusbar.Item(1) := "Found " + ALLTRIM(STR(found_rec)) + " record(s)!"
      ENDIF
   ENDIF

   DisableField_9213()

   Win_1.Browse_1.Refresh
   Win_1.Browse_1.Enabled   := .T.

RETURN
*---------------------------------------------*
PROCEDURE PreQuery_9213

_qry_exp := ""
_ima_filter := .F.

IF ! EMPTY ( Win_1.mID.Value )     // ID
   IF _ima_filter
      _qry_exp = _qry_exp + " .AND. "
   ENDIF
      _qry_exp = _qry_exp + "ID = " + STR( Win_1.mID.Value )
      _ima_filter := .T.
ENDIF

IF ! EMPTY ( Win_1.mDESCRIPT.Value )     // DESCRIPT
   IF _ima_filter
      _qry_exp = _qry_exp + " .AND. "
   ENDIF
      _qry_exp = _qry_exp + "DESCRIPT = " + chr(34) + Win_1.mDESCRIPT.Value + chr(34)
      _ima_filter := .T.
ENDIF

RETURN
*:***********************************************
function closetables1 ()

   dbcloseall()

return 0
* end of program *


